## beads 1.1.22%2Bds

=== debian/changelog ===
beads (1.1.22+ds-1) unstable; urgency=medium

  * d/watch:
     - version=5
     - Do not report new or old versions
  * Fix clean target
    Closes: #1043686
  * Drop copy of CImg.h from package source
  * Remove trailing whitespace in debian/changelog (routine-update)

 -- Andreas Tille <tille@debian.org>  Thu, 16 Oct 2025 14:18:16 +0200

## beads 1.1.22+ds

=== CMakeLists.txt ===

# cmake helps to compile "beads"
# please install the cmake package depending on your linux distribution
# and type in the beads root directory :
# cmake .
# make
# make install
cmake_minimum_required(VERSION 2.18.4)


# The name of our project is "beads".  CMakeLists files in this project can
# refer to the root source directory of the project as ${beads_SOURCE_DIR} and
# to the root binary directory of the project as ${beads_BINARY_DIR}.
project(beads CXX C)



# We want C++17
set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
message(STATUS "${BoldGreen}CMAKE_CXX_COMPILER: ${CMAKE_CXX_COMPILER}${ColourReset}")

#IF( CMAKE_BASE_NAME MATCHES "cl")
#	message("on est sous Windows")
#	SET( WIN32 "true")
#ENDIF(CMAKE_BASE_NAME MATCHES "cl")

if(NOT CMAKE_BUILD_TYPE)
	set( CMAKE_BUILD_TYPE "Release")
endif(NOT CMAKE_BUILD_TYPE)

if(NOT CMAKE_INSTALL_PREFIX)
	set(CMAKE_INSTALL_PREFIX /usr/local)
endif(NOT CMAKE_INSTALL_PREFIX)


if( CMAKE_BUILD_TYPE MATCHES "Release")
	message("compiling as release version")
	add_definitions("-DQT_NO_DEBUG_OUTPUT")
else( CMAKE_BUILD_TYPE MATCHES "Release" )
	message("compiling as debug version")
endif( CMAKE_BUILD_TYPE MATCHES "Release" )



#SET(WIN32 "true")
#SET(MINGW "true")

#set(CMAKE_MODULE_PATH ${beads_SOURCE_DIR}/cmake_modules)

#IF( PTHREADS_FOUND )
#	INCLUDE_DIRECTORIES( ${PTHREADS_INCLUDE_DIR} )
#ELSE( PTHREADS_FOUND )
#	MESSAGE( FATAL_ERROR "No pthread installed" )
#ENDIF( PTHREADS_FOUND )



set( EXTRA_CIMG_LIBRARY "")

set( CIMG_OS 0)
if(WIN32)
	set( CIMG_OS 2)
	#-O2 -lgdi32
	#SET( EXTRA_CIMG_LIBRARY "gdi32")
	#SET(CMAKE_CXX_FLAGS_RELEASE "-O2 -DNDEBUG")
	#	FIND_PACKAGE(FindMagick REQUIRED)
else(WIN32)
	#FIND_PACKAGE(Pthreads REQUIRED)
	set(CMAKE_CXX_FLAGS_RELEASE "-s -O3 -DNDEBUG")
	set( CIMG_OS 1)
endif(WIN32)

#
#CMAKE_CXX_FLAGS
set(CMAKE_CXX_FLAGS_DEBUG "-g -s")
set(CMAKE_CXX_FLAGS_MINSIZEREL "-Os -DNDEBUG")
set(CMAKE_CXX_FLAGS_RELWITHDEBINFO "-O2 -g")

set(BEADS_VERSION "1.1.22")
set(VERSION 1.1.22)

set(CPACK_CMAKE_GENERATOR "Unix Makefiles")
set(CPACK_GENERATOR "STGZ;TGZ;TZ")
#SET(CPACK_INSTALL_CMAKE_PROJECTS "/tmp;beads;src;/src")
#SET(CPACK_NSIS_DISPLAY_NAME "CMake 2.5")
set(CPACK_OUTPUT_CONFIG_FILE "./CPackConfig.cmake")
set(CPACK_PACKAGE_DESCRIPTION_FILE ${beads_SOURCE_DIR}/COPYING)
set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "beads is a detection software")
set(CPACK_PACKAGE_EXECUTABLES "beads")
set(CPACK_SOURCE_PACKAGE_FILE_NAME "beads-${BEADS_VERSION}")
set(CPACK_PACKAGE_FILE_NAME "beads-${BEADS_VERSION}-Linux-i686")
set(CPACK_PACKAGE_INSTALL_DIRECTORY "beads ${BEADS_VERSION}")
set(CPACK_PACKAGE_INSTALL_REGISTRY_KEY "beads ${BEADS_VERSION}")
set(CPACK_PACKAGE_NAME "beads")
set(CPACK_PACKAGE_VENDOR "CNRS")

if( CMAKE_BUILD_TYPE MATCHES "Debug")
	set(BEADS_VERSION "${BEADS_VERSION}d")
endif( CMAKE_BUILD_TYPE MATCHES "Debug")
set(CPACK_PACKAGE_VERSION ${BEADS_VERSION})
set(CPACK_PACKAGE_VERSION_MAJOR "1")
set(CPACK_PACKAGE_VERSION_MINOR "1")
set(CPACK_PACKAGE_VERSION_PATCH "15")
set(CPACK_RESOURCE_FILE_LICENSE ${beads_SOURCE_DIR}/COPYING)
set(CPACK_RESOURCE_FILE_README ${beads_SOURCE_DIR}/README)
set(CPACK_RESOURCE_FILE_WELCOME ${beads_SOURCE_DIR}/INSTALL)
set(CPACK_SOURCE_GENERATOR "TGZ;TZ")
set(CPACK_SOURCE_OUTPUT_CONFIG_FILE "./CPackSourceConfig.cmake")
set(CPACK_SYSTEM_NAME "Linux-i686")
set(CPACK_TOPLEVEL_TAG "Linux-i686")

set(CPACK_SOURCE_IGNORE_FILES 
	"moc_.*cxx"
	"/devel_archives/"
	"/build/"
	"/buildw64/"
	"/cbuild/"
	"/figures/"
	".*\\\\.so"
	".*\\\\.a"
	"/Soumis/"
	"/samples/"
	"/win32/"
	"/tests/"
	"Makefile"
	"install_manifest.txt"
	"cmake_install.cmake"
	"cmake_install.cmake"
	"CMakeCache.txt"
	"CPackConfig.cmake"
	"CPackSourceConfig.cmake"
	"install_manifest.txt"
	".gitignore"
	"/CMakeFiles/"
	"/_CPack_Packages/"
	"/Debug/"
	"/Release/"
	"/\\\\.externalToolBuilders/"
	"/\\\\.git/"
	"/\\\\.settings/"
	"Makefile"
	"\\\\.cdtbuild"
	"\\\\.cdtproject"
	"\\\\.project"
	"\\\\.cproject"
	"beads$"
	".*\\\\.tar\\\\.gz"
	)
# cpack -G TGZ --config CPackSourceConfig.cmake
# dpkg-buildpackage -rfakeroot

#.dput.cf
#[olivier-langella]
#fqdn = ppa.launchpad.net
#method = ftp
#incoming = ~olivier-langella/ubuntu/
#login = olivier-langella
#allow_unsigned_uploads = 0
#
#  debuild -S -sa
# dput -f olivier-langella *changes





#dch -Djessie "message"
#cmake ..
#make deb
# scp beads* proteus.moulon.inra.fr:/var/www/apt/incoming
# reprepro -Vb /var/www/apt processincoming default


configure_file(${beads_SOURCE_DIR}/src/config.h.cmake ${beads_SOURCE_DIR}/src/config.h)


set(CPACK_PACKAGE_EXECUTABLES "beads" "beads")


include(CPack)


#INCLUDE(CPack)




# Recurse into the "src" subdirectories.  This does not actually
# cause another cmake executable to run.  The same process will walk through
# the project's entire directory structure.
#ADD_DEFINITIONS( -lpthread)
add_subdirectory(src)

#SET(CPACK_STRIP_FILES "src/beads;src/qtbeads/qtbeads")

install(PROGRAMS ${CMAKE_BINARY_DIR}/src/beads DESTINATION bin)
install(PROGRAMS ${CMAKE_BINARY_DIR}/src/qtbeads/qtbeads DESTINATION bin)
#INSTALL(DIRECTORY doc/man1 DESTINATION share/man/man1)
install(FILES doc/man1/beads.1 DESTINATION share/man/man1)
install(FILES share/applications/beads.desktop DESTINATION share/applications)
install(FILES share/beads/beads_blue.conf DESTINATION share/beads)
install(FILES share/beads/beads_silver.conf DESTINATION share/beads)
install(FILES share/beads/beads_silver_small.conf DESTINATION share/beads)
install(FILES share/beads/beads_icon.svg DESTINATION share/beads)

add_custom_target(targz
	cpack -G TGZ --config CPackSourceConfig.cmake && tar xvfz beads-${BEADS_VERSION}.tar.gz
	WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
	COMMENT "Creating .tar.gz" VERBATIM
	)


add_custom_target(deb
	cd beads-${BEADS_VERSION} && dpkg-buildpackage -b
	DEPENDS targz
	WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
	COMMENT "Creating Debian package" VERBATIM
	)

=== src/CMakeLists.txt ===
find_package( Qt6 COMPONENTS Core Gui Xml REQUIRED )
find_package(QuaZip-Qt6 REQUIRED)

list( APPEND CMAKE_MODULE_PATH
	${PROJECT_SOURCE_DIR}/cmake_modules
	)

set(CImg_INCLUDE_DIR "${CMAKE_SOURCE_DIR}/src/cimg")

if(DEBIAN_PACKAGE)
	#  CImg_FOUND - system has CImg lib
	set(CImg_FOUND 1)
	#  CImg_INCLUDE_DIRS - the CImg include directory
	set(CImg_INCLUDE_DIR "/usr/include")
	#  CImg_SYSTEM_LIBS - external libraries that CImg uses
	set(CImg_SYSTEM_LIBS "/usr/lib${LIB_SUFFIX}/libz.so"
		"/usr/lib${LIB_SUFFIX}/libpng16.so"
		"/usr/lib${LIB_SUFFIX}/libjpeg.so"
		"/usr/lib${LIB_SUFFIX}/libtiff.so")
	#  CImg_SYSTEM_LIBS_DIR - external library directories
	set(CImg_SYSTEM_LIBS_DIR "")
	#  CImg_CFLAGS - compilation flags
	set(CImg_CFLAGS "pthread" "-Dcimg_use_png" "-Dcimg_use_jpeg" "-Dcimg_use_tiff" "-Dcimg_use_zlib")

else(DEBIAN_PACKAGE)
	find_package( CImg REQUIRED )
endif(DEBIAN_PACKAGE)

# Add CIMG Flags to Compilation Flags
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${CIMG_CFLAGS}")

#include_directories(${OdsStream_INCLUDE_DIRS})

if(MINGW32)
	include_directories( ${QUAZIP_INCLUDE_DIR} )
else(MINGW32)
	find_package( OdsStream REQUIRED )
endif(MINGW32)



set( BEADS_FOR_QT_CPP
	ConfigFile/ConfigFile.cpp
	parameters.cpp
	encode/base64.cpp
	images/imageIntensity.cpp
	images/imageDirect.cpp
	images/imageCode.h
	images/imageCoule.cpp
	images/imagePaths.cpp
	images/imageConfluent.cpp
	images/imageProb.cpp
	images/parameterProb.cpp
	parameterDetection.cpp
	images/parameterConfluent.cpp
	detection.cpp
	images/imageDetection.cpp
	images/imageNumber.cpp
	images/parameterNumber.cpp
	images/imageContours.cpp
	spotPROTICdbDocument.cpp
	spot.cpp
	spotDocument.cpp
	spotSvgDocument.cpp
	images/imageDeNovo.cpp
	)

if(WIN32)
else(WIN32)
	#FIND_PACKAGE(X11 REQUIRED)

	#INCLUDE_DIRECTORIES(X11_INCLUDE_DIR)
	# X11_FOUND is true if X11 is available.
	#    * X11_INCLUDE_DIR contains the include directories to use X11.
	#    * X11_LIBRARIES points to the libraries to link against to use X11.
	# Make sure the compiler can find include files from our Hello library.
	#include_directories(${X11_INCLUDE_DIR})

	#ADD_DEFINITIONS(${PTHREADS_DEFINITIONS})
	# -m -pthread FindThreads

	# Make sure the linker can find the Hello library once it is built.
	#link_directories(${X11_INCLUDE_DIR})
endif(WIN32)


add_executable(beads beads.cpp )
target_include_directories(beads PUBLIC $${CImg_INCLUDE_DIRS} ${CImg_SYSTEM_LIBS_DIR})
set_target_properties(beads
	PROPERTIES OUTPUT_NAME beads
	CLEAN_DIRECT_OUTPUT 1
	CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${CImg_CFLAGS}"
	)

target_link_libraries(beads cppbeads
	${CImg_SYSTEM_LIBS}
	${CImg_CFLAGS}
	Qt6::Core
	Qt6::Gui
	Qt6::Xml
	OdsStream::Core
	)


add_library(cppbeads STATIC
	${BEADS_FOR_QT_CPP}
	)

target_include_directories(cppbeads PUBLIC ${OdsStream_INCLUDE_DIRS}
	${CImg_INCLUDE_DIRS} ${CImg_SYSTEM_LIBS_DIR})
set_target_properties(cppbeads
	PROPERTIES OUTPUT_NAME cppbeads-qt6
	CLEAN_DIRECT_OUTPUT 1
	CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${CImg_CFLAGS}"
	)

target_link_libraries(cppbeads
	${CImg_SYSTEM_LIBS}
	${CImg_CFLAGS}
	Qt6::Core
	Qt6::Gui
	Qt6::Xml
	OdsStream::Core
	)


subdirs(qtbeads)

=== src/ConfigFile/Makefile ===
# Makefile for ConfigFile class

CC = g++
CFLAGS = -Wall -ansi

all: example tester

example: example.cpp ConfigFile.cpp
	$(CC) $(CFLAGS) -o example example.cpp ConfigFile.cpp

tester: tester.cpp ConfigFile.cpp
	$(CC) $(CFLAGS) -o tester tester.cpp ConfigFile.cpp

run: example
	./example | tee example.out

test: tester
	./tester | tee test.out

tidy:
	@ rm -f *.o

clean: tidy
	@ rm -f example tester example.out test.out core*

=== src/qtbeads/CMakeLists.txt ===

find_package( Qt6 COMPONENTS Core Gui Xml Widgets PrintSupport REQUIRED )

# add some useful macros and variables
# (QT_USE_FILE is a variable defined by FIND_PACKAGE( Qt4 ) that contains a path to CMake script)
#INCLUDE( ${QT_USE_FILE} )

# with SET() command you can change variables or define new ones
# here we define SAMPLE_SRCS variable that contains a list of all .cpp files
# note that we don't need \ at the end of line
set( QTBEADS_SRCS
	qtbeads.cpp
	main_window.cpp
	properties.cpp
	beads_results.cpp
	QCimg.cpp
	q_gel_image.cpp
	q_gel_image_scroll.cpp
	#	qtbeads_error.h
	)

# another list, this time it includes all header files that should be treated with moc
set( QTBEADS_MOC_HDRS
	main_window.h
	q_gel_image.h
	)  
# some .ui files
#SET( SAMPLE_UIS
#     ./src/ui/Dialog1.ui
#     ./src/ui/Dialog2.ui
#)

# and finally an resource file
#SET( SAMPLE_RCS
#     ./src/rc/sample.qrc
#)

# enable warnings
#ADD_DEFINITIONS( -Wall )

# by default only QtCore and QtGui modules are enabled
# other modules must be enabled like this:
#SET( QT_USE_QT3SUPPORT TRUE )   
# SET( QT_USE_QTXML TRUE )




# this command will generate rules that will run rcc on all files from SAMPLE_RCS
# in result SAMPLE_RC_SRCS variable will contain paths to files produced by rcc
qt6_add_resources( QTBEADS_SRCS ${SAMPLE_RCS} )

# this will run uic on .ui files:
#QT4_WRAP_UI( SAMPLE_UI_HDRS ${SAMPLE_UIS} )

# and finally this will run moc:
qt6_wrap_cpp( QTBEADS_MOC_SRCS ${QTBEADS_MOC_HDRS} )

# we need this to be able to include headers produced by uic in our code
# (CMAKE_BINARY_DIR holds a path to the build directory, while INCLUDE_DIRECTORIES() works just like INCLUDEPATH from qmake)
#INCLUDE_DIRECTORIES( ${CMAKE_BINARY_DIR} ${Qwt5_INCLUDE_DIR})



# here we instruct CMake to build "sample" executable from all of the source files
add_executable( qtbeads ${QTBEADS_SRCS} ${QTBEADS_MOC_SRCS} ${SAMPLE_RC_SRCS} ${SAMPLE_UI_HDRS} ${QM} )

target_include_directories(qtbeads PUBLIC ${CMAKE_BINARY_DIR}
	${OdsStream_INCLUDE_DIRS} 
	${CImg_INCLUDE_DIRS})


if(WIN32)
	set_target_properties(qtbeads
		PROPERTIES 
		LINK_FLAGS "-Wl,--subsystem,windows ${ADD_MINGW_EXE_LINKER_FLAGS}"
		CLEAN_DIRECT_OUTPUT 1
		CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${CImg_CFLAGS} ${QT_QTCORE_EXECUTABLE_COMPILE_FLAGS}"
		)
else(WIN32)
	set_target_properties(qtbeads
		PROPERTIES
		CLEAN_DIRECT_OUTPUT 1
		CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${CImg_CFLAGS}"
		)
endif(WIN32)

target_link_libraries(qtbeads cppbeads OdsStream::Core ${CImg_SYSTEM_LIBS} Qt6::Core Qt6::Gui Qt6::Xml Qt6::Widgets Qt6::PrintSupport)

=== debian/control ===
Source: beads
Standards-Version: 4.7.2
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders:
 Andreas Tille <tille@debian.org>,
 Filippo Rusconi <lopippo@debian.org>,
Section: science
Priority: optional
Build-Depends:
 debhelper-compat (= 13),
 cmake,
 qtbase5-dev,
 cimg-dev,
 libodsstream-dev,
Vcs-Browser: https://salsa.debian.org/med-team/beads
Vcs-Git: https://salsa.debian.org/med-team/beads.git
Homepage: http://pappso.inrae.fr/bioinfo/beads

Package: beads
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 imagemagick,
Description: 2-DE electrophoresis gel image spot detection
 Beads is a program for spot detection on 2-D gel images. It is based on
 an analogy with beads flowing uphill on the surface of the gel image and
 on the analysis of their paths (Langella & Zivy, 2008).

=== debian/watch ===
Version: 5

Source: https://forgemia.inra.fr/pappso/@PACKAGE@/-/tags?sort=updated_desc
Matching-Pattern: .*/tags/upstream%2F(\d[\d.]+)
# Matching-Pattern: (?:.*?/)?(beads_)?(\d[\d.]+)@ARCHIVE_EXT@
Dversion-Mangle: s/1\.1\.2[12]\+ds/1.1.20/

# The following page has all the tags.
# https://forgemia.inra.fr/pappso/beads/-/tags
# The page above has the links in the following format
# href="/pappso/beads/-/archive/1.1.20/beads-1.1.20.zip"
# Version 1.1.2[12] where just released in Debian
# The upstream project is dead but this watch file does not report new (or just older) versions
